using ICSSoft.Common;
using ICSSoft.Entity;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSSoft.DataProject
{
    /// <summary>
    /// 借用(生成其他出库单)
    /// </summary>
    public class BrrowDoc
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        private static string Type = System.Configuration.ConfigurationManager.AppSettings["Type"];
        private static string CRNALL = System.Configuration.ConfigurationManager.AppSettings["BrrowCRDNAME"];
        /// <summary>
        /// 借用(生成其他出库单)
        /// </summary>
        /// <param name="Bills"></param>
        /// <returns></returns>
        public string ConfirmRd09(List<ICSBrrowDoc> Bills)
        {
            string msg = string.Empty;
            string connS = "";
            string sql = string.Empty;
            SqlConnection conn = new SqlConnection();
            DataSet ds = null;
            int num = 0;
            SqlCommand cmd = new SqlCommand();
            string iFatherIdTwo = "";



            if (Bills.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            LogInfo(Bills);
            //log.Info("-------合并前-------");
            //log.Info("-------合并后-------");
            //List<RdRecord09> Vouchers = new List<RdRecord09>();




            List<string> result = Bills.Select(t => t.WorkPoint).Distinct().ToList();
            foreach (string WorkPoint in result)
            {
                try
                {
                    connS = string.Format(connString, WorkPoint);
                    conn = new System.Data.SqlClient.SqlConnection(connS);
                    conn.Open();
                    SqlTransaction sqlTran = conn.BeginTransaction();
                    cmd = new SqlCommand();
                    cmd.Transaction = sqlTran;
                    cmd.Connection = conn;



                    foreach (ICSBrrowDoc head in Bills)
                    {
                        iFatherIdTwo = "";
                        if (WorkPoint != head.WorkPoint)
                        {
                            continue;
                        }
                        if (!DBHelper.IsInventoryConsolidation(cmd, head.WorkPoint))
                            throw new Exception("U8正在整理现存量，请稍后再试");
                  

                        string[] ss = head.WorkPoint.Split('_');
                        ERPDB = ss[1];

                        string[] dd = CRNALL.Split('~');
                        string crdname = dd[0];
                        string carname = dd[1];
                        string surface = dd[2];

                        num = head.details.Count();
                        string cardnewcode = DBHelper.GetCardNumber(carname, cmd);
                        Dictionary<string, int> dic = DBHelper.GetAllCode("" + ERPDB + "", surface, "" + num + "", head.WorkPoint);
                        int iFatherId = Convert.ToInt32(dic["iFatherId"].ToString());
                        int iChildId = Convert.ToInt32(dic["iChildId"].ToString());
                        DateTime date = DateTime.Now;
                        string cRDcode = DBHelper.GetRDCode(crdname, cmd);
                        string iBaseCodeLen = DBHelper.GetAllRDCode(cardnewcode, "" + date + "", "admin", cRDcode, head.WorkPoint);


                        ICSUserInfo userInfo = new ICSUserInfo();
                        userInfo = DBHelper.GetPersonInfo(head.User, cmd);
                        //取得out库单的默认显示模版
                        string DEF_ID09 = DBHelper.GetDefaultTemplate(cardnewcode, cmd);
                        //取得其他出库单单据 表头ID，表体DID
                        VouchKey key09 = new VouchKey();
                        #region  其他出库单表头
                        key09.ID += 1;
                        sql = @"INSERT INTO dbo.RdRecord09
                            ( ID ,bRdFlag ,cVouchType ,cBusType ,cSource ,cWhCode ,dDate ,cCode ,
                              cRdCode ,cDepCode ,cHandler ,bTransFlag ,cMaker ,dVeriDate ,bpufirst ,
                              biafirst ,VT_ID ,bIsSTQc ,bFromPreYear ,bIsComplement ,iDiscountTaxType ,
                              iBG_OverFlag ,cBG_Auditor ,cBG_AuditTime ,ControlResult ,ireturncount ,
                              iverifystate ,iswfcontrolled ,cModifyPerson ,dnmaketime ,dnverifytime ,
                              iPrintCount,cBusCode )
                    VALUES(@ID,0,'09','其他出库','借出借用单',@cWhCode,CONVERT(NVARCHAR(15),GETDATE(),23),@cCode,
                    		@cRdCode,@cDepCode,@cHandler,0,@cMaker,CONVERT(NVARCHAR(15),GETDATE(),23),0,
                    		0,@VT_ID,0,0,0,0,
                    		0,'','',-1,0,
                    		0,0,'',GETDATE(),GETDATE(),0,@cBusCode) ";

                        cmd.Parameters.Clear();
                        cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                        cmd.Parameters.Add(new SqlParameter("@cWhCode", head.WHCode));
                        cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
                        cmd.Parameters.Add(new SqlParameter("@cRdCode", cRDcode));
                        cmd.Parameters.Add(new SqlParameter("@cDepCode", head.DepCode));
                        cmd.Parameters.Add(new SqlParameter("@cHandler", userInfo.UserName));
                        cmd.Parameters.Add(new SqlParameter("@cMaker", userInfo.UserName));
                        cmd.Parameters.Add(new SqlParameter("@VT_ID", DEF_ID09));
                        cmd.Parameters.Add(new SqlParameter("@cBusCode", head.SourceCode));
                        cmd.CommandText = sql;
                        try
                        {
                            cmd.ExecuteNonQuery();
                        }
                        catch (Exception)
                        {
                            log.Error("生成其他出库单失败！SQL：\r\n" + sql);
                            throw new Exception("程序异常，请联系开发人员！");
                        }
                        #endregion
                        foreach (ICSBrrowDocs body in head.details)
                        {
                            #region 3.5.1 表体
                            sql = @"INSERT INTO dbo.rdrecords09
                                        ( AutoID ,ID ,cInvCode ,iQuantity ,iFlag ,bLPUseFree ,iRSRowNO ,iOriTrackID ,cBatch,iNNum,cItemCode,
                                          bCosting ,bVMIUsed ,iExpiratDateCalcu ,iordertype ,isotype ,irowno ,iposflag,iDebitIDs ,cFree1,cFree2,cFree3,cFree4,cFree5,cFree6,cFree7,cFree8,cFree9,cFree10)
                                VALUES(@AutoID,@ID,@cInvCode,@iQuantity,0,0,0,0,@cBatch,@iNNum,@cItemCode,
                                		1,0,0,0,0,@irowno,1,@iDebitIDs,@cFree1,@cFree2,@cFree3,@cFree4,@cFree5,@cFree6,@cFree7,@cFree8,@cFree9,@cFree10)";

                            cmd.Parameters.Clear();
                            cmd.Parameters.Add(new SqlParameter("@AutoID", iChildId));
                            cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                            cmd.Parameters.Add(new SqlParameter("@cInvCode", body.InvCode));
                            cmd.Parameters.Add(new SqlParameter("@iQuantity", body.Quantity));
                            cmd.Parameters.Add(new SqlParameter("@iNNum", body.Amount.ToString("0.00")));
                            cmd.Parameters.Add(new SqlParameter("@irowno", body.Sequence));
                            cmd.Parameters.Add(new SqlParameter("@iDebitIDs", body.SourceDetailID));
                            cmd.Parameters.Add(new SqlParameter("@cBatch", body.BatchCode));
                            cmd.Parameters.Add(new SqlParameter("@cItemCode", body.ProjectCode));
                            cmd.Parameters.Add(new SqlParameter("@cFree1", body.cFree1));
                            cmd.Parameters.Add(new SqlParameter("@cFree2", body.cFree2));
                            cmd.Parameters.Add(new SqlParameter("@cFree3", body.cFree3));
                            cmd.Parameters.Add(new SqlParameter("@cFree4", body.cFree4));
                            cmd.Parameters.Add(new SqlParameter("@cFree5", body.cFree5));
                            cmd.Parameters.Add(new SqlParameter("@cFree6", body.cFree6));
                            cmd.Parameters.Add(new SqlParameter("@cFree7", body.cFree7));
                            cmd.Parameters.Add(new SqlParameter("@cFree8", body.cFree8));
                            cmd.Parameters.Add(new SqlParameter("@cFree9", body.cFree9));
                            cmd.Parameters.Add(new SqlParameter("@cFree10", body.cFree10));
                            cmd.CommandText = sql;
                            try
                            {
                                cmd.ExecuteNonQuery();
                            }
                            catch (Exception)
                            {
                                log.Error("生成其他出库单表体失败！SQL：\r\n" + sql);
                                throw new Exception("程序异常，请联系开发人员！");
                            }
                            #endregion

                            sql = @"select isnull(iQtyRK,0)fOutQuantity,isnull(iQuantity,0)iQuantity,ISNULL(iNum, 0)iNum,ISNULL(NiNum, 0)NiNum,ISNULL(iNum, 0)-ISNULL(NiNum, 0) SiNum from HY_DZ_BorrowOutBacks a
                        LEFT JOIN (select sum(iNum) NiNum,iDebitIDs from rdrecords09 GROUP BY iDebitIDs) b on a.AutoID=b.iDebitIDs
                        where  a.AutoID='" + body.SourceDetailID + "'";
                            DataTable dtDisCheck = DBHelper.SQlReturnData(sql, cmd);
                            if (dtDisCheck != null && dtDisCheck.Rows.Count > 0)
                            {
                                foreach (DataRow item in dtDisCheck.Rows)
                                {
                                    if (Convert.ToDecimal(item["fOutQuantity"].ToString()) == Convert.ToDecimal(item["iQuantity"].ToString()))
                                    {
                                        if (Convert.ToDecimal(item["iNum"].ToString()) != 0)
                                        {
                                            if (Convert.ToDecimal(item["SiNum"].ToString()) != 0)
                                            {
                                                sql = @"Update rdrecords09 set iNum=isnull(iNum,0)+(" + item["SiNum"].ToString() + ") where autoid='" + iChildId + "' ";
                                                body.Amount = (Convert.ToDecimal(body.Amount.ToString("0.00"))) + (Convert.ToDecimal(item["SiNum"].ToString()));
                                                DBHelper.CmdExecuteNonQuery(sql, cmd, "辅计量余数处理失败！");
                                            }
                                        }
                                    }
                                }

                            }

                            sql = @"UPDATE a SET iQtyOut=ISNULL(iQtyOut,0)+" + body.Quantity + @" 
                                FROM dbo.HY_DZ_BorrowOuts a
                                WHERE a.Autoid='" + body.SourceDetailID + "'";
                            DBHelper.CmdExecuteNonQuery(sql, cmd, "回写借入单数量失败！");



                            //更新现存量
                            key09.cBustypeUN = "调拨出库";
                            key09.cVouchTypeUN = "09";
                            key09.TableName = "IA_ST_UnAccountVouch09";

                            //DBHelper.UpdateCurrentStock(cmd, body.InvCode, head.WHCode, "", -body.Quantity, key09);
                            //DBHelper.UpdateCurrentStockNEW(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, body.cFree1, body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10, key09);
                            DBHelper.UpdateCurrentStockCCGC(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, -body.Amount, body.cFree1,
                                body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10,
                                "", key09, "", "", "", "", 0, 0, 0, 0, 0, 0, 0, 0, iFatherId, iChildId);
                      
                         



                            iFatherIdTwo = "'" + iFatherId + "',";
                            iChildId--;

                        }

                        //OM_MODetails
                        #region 查询
                        sql = @"  
                            select DISTINCT a.ID as ID,a.ID as IDs,cBusCode as SourceCode ,
                           cCode as OtherOutCode,a.cDepCode,c.cDepName,a.cWhCode,d.cWhName,
                            cSource as SourceType,cMaker as CreateUser,dnmaketime as CreateDateTime,
                            cHandler as Checker,dnverifytime as CheckDateTime
                            from rdrecord09 a
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            WHERE a.ID in ({0})

                           select DISTINCT a.ID as IDs,b.AutoID as DetailID,irowno as Sequence,b.cInvCode as InvCode 
                           ,iQuantity as Quantity,b.iDebitIDs as SourceDetailID,iNum as Amount
                            ,isnull(b.cItemCode,'') ProjectCode,
                            isnull(b.cbatch,'') cBatch,
                            '' version ,'' brand,
                            isnull(b.cFree1,'') as cFree1,
                            isnull(b.cFree2,'') as cFree2,
                            isnull(b.cFree3,'') as cFree3,
                            isnull(b.cFree4,'') as cFree4,
                            isnull(b.cFree5,'') as cFree5,
                            isnull(b.cFree6,'') as cFree6,
                            isnull(b.cFree7,'') as cFree7,
                            isnull(b.cFree8,'') as cFree8,
                            isnull(b.cFree9,'') as cFree9,
                            isnull(b.cFree10,'') as cFree10
                            from rdrecord09 a
                            left join rdrecords09 b on a.ID=b.ID
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                             WHERE a.ID in ({0})";
                        sql = string.Format(sql, iFatherIdTwo.TrimEnd(','));

                        if (ds != null)
                            ds.Merge(DBHelper.SQlReturnDataSet(sql, cmd));
                        else
                            ds = DBHelper.SQlReturnDataSet(sql, cmd);
                        #endregion

                    }
                    cmd.Transaction.Commit();
                }
                catch (Exception ex)
                {
                    cmd.Transaction.Rollback();
                    log.Error(ex.Message);
                    throw new Exception(ex.Message);
                }
                finally
                {
                    if (conn.State == ConnectionState.Open)
                    {
                        conn.Close();
                    }
                    conn.Dispose();
                }
            }
            msg = JSON.DataSetToJson(ds, "details", "IDs");
            return msg;


        }
        /// <summary>
        /// 记录日志
        /// </summary>
        /// <param name="Bills"></param>
        private void LogInfo(List<ICSBrrowDoc> Bills)
        {
            string HeadList = string.Empty;
            string BodyList = string.Empty;
            foreach (ICSBrrowDoc head in Bills)
            {
                HeadList += "\r\n 借用单号：" + head.SourceCode + "，用户：" + head.User + "，站点：" + head.WorkPoint + "";

            }
            log.Info(HeadList);
            log.Info(BodyList);
        }

    }
}

